﻿using Telerik.Windows.Controls;
using Telerik.Windows.Controls.DragDrop;
using System.Windows;
using System.Windows.Controls;

namespace DockingDragDropWithListBoxSL
{
	public class AllowOutsideDropDocking : RadDocking
	{
		private void OnDropInfo(object sender, DragDropEventArgs e)
		{
			var container = e.Options.Payload as RadSplitContainer;
			if (container != null)
			{
				if (e.Options.Status == DragStatus.DropPossible)
				{
					this.OnDragContainer(container, e.Options.CurrentDragPoint);
				}
				else if (e.Options.Status == DragStatus.DropComplete)
				{
					if (this.OnDropContainer(container, e.Options.CurrentDragPoint))
					{
						// TODO: If you need to remove the item from the ListBox data collection you should do it here.
						var item = e.Options.Source as ContentControl;
						if (item != null)
						{
							var listBox = item.ParentOfType<System.Windows.Controls.ItemsControl>();
							if (listBox != null)
							{
								listBox.Items.Remove(item.DataContext);
							}
						}
					}
				}
			}
		}

		public void CancelDrag()
		{
			this.OnDropContainer(null, new Point());
		}

		private RadSplitContainer draggedContainer;

		public void BeginDrag(FrameworkElement element, RadSplitContainer container)
		{
			if (element.CaptureMouse())
			{
				element.MouseMove += this.element_MouseMove;
				element.LostMouseCapture += this.element_LostMouseCapture;
				draggedContainer = container;
			}	
		}

		private void element_LostMouseCapture(object sender, System.Windows.Input.MouseEventArgs e)
		{
			var element = sender as FrameworkElement;
			element.MouseMove -= this.element_MouseMove;
			element.LostMouseCapture -= this.element_LostMouseCapture;
			this.OnDropContainer(draggedContainer, e.GetPosition(null));
		}

		private void element_MouseMove(object sender, System.Windows.Input.MouseEventArgs e)
		{
			this.OnDragContainer(draggedContainer, e.GetPosition(null));
		}
	}
}
