﻿using System.Windows;
using System.Windows.Controls;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.DragDrop;
using Telerik.Windows.DragDrop;

namespace DockingDragDropWithListBoxSL
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			InitializeComponent();
			DragDropManager.AddDragInitializeHandler(this.leftListBox, this.OnDragInitialize);
		}

		private void OnDragInitialize(object sender, DragInitializeEventArgs e)
		{
			e.Cancel = true;

			var element = e.OriginalSource as FrameworkElement;
			if (element != null)
			{
				this.myDock.BeginDrag(element, GenerateContainer(element));
			}
		}

		private RadSplitContainer GenerateContainer(FrameworkElement element)
		{
			var data = element.DataContext as MyData;
			var container = new RadSplitContainer();
			var group = new RadPaneGroup();
			var pane = new RadPane { Header = data.ListBoxItemName, Content = new TextBlock { Text = data.Number.ToString() } };
			group.Items.Add(pane);
			container.Items.Add(group);

			return container;
		}
	}
}